<template>
  <div class="ext-query-builder">
    <query-builder-group
      v-model="query"
      :rules="rules"
      :labels="labels"
      :max-depth="maxDepth"
      :disable="disable"
      @input="handleQueryBuilderChange"
    />
  </div>
</template>

<script>
import { cloneDeep } from 'lodash'
import QueryBuilderGroup from './QueryBuilderGroup.vue'

const defaultLabels = {
  matchType: 'Match',
  matchTypes: [
    { id: 1, label: 'Any' },
    { id: 2, label: 'All' },
  ],
  addRule: 'Add condition',
  removeRule: 'Remove condition',
  addGroup: 'Add group',
  removeGroup: 'Remove group',
  textInputPlaceholder: 'value',
}

export default {
  name: 'QueryBuilder',
  components: {
    QueryBuilderGroup,
  },
  props: {
    rules: {
      type: Array,
      default() {
        return []
      },
    },
    labels: {
      type: Object,
      default() {
        return defaultLabels
      },
    },
    maxDepth: {
      type: Number,
      default: 3,
      validator(value) {
        return value >= 1
      },
    },
    value: {
      type: Object,
      default() {
        return {}
      },
    },
    disable: {
      type: Boolean,
      default() {
        return false
      },
    },
  },
  data() {
    return {
      query: {
        logicalOperator: this.labels.matchTypes[0].id,
        childRules: [],
      },
    }
  },
  created() {
    if (this.value.logicalOperator) this.query = cloneDeep(this.value)
  },
  methods: {
    handleQueryBuilderChange() {
      this.$emit('input', this.query)
    },
  },
}
</script>
